package org.autochthonous.graphics.rt;

import javax.vecmath.*;

public class AtmosphereData
{
    private static AtmosphereData    list = null;

    private float        mixFactor;
    private Color3f     col = new Color3f();

    AtmosphereData    next;

    public static AtmosphereData getInstance(
        float            mixFactor,
        Color3f        col)
    {
        AtmosphereData    p;

        if (list == null)
        {
            p = new AtmosphereData();
        }
        else
        {
            p = list;
            list = list.next;
        }        

        p.mixFactor = mixFactor;
        p.col.set(col);
        p.next = null;

        return p;
    }

    public void dispose()
    {
        this.next = list;
        list = this;
    }

    public float mixFactor()
    {
        return mixFactor;
    }

    public Color3f color()
    {
        return col;
    }
}
