package org.autochthonous.graphics.rt;

public class AtmosphereDataList
{
    private AtmosphereData data;
    private AtmosphereData tail;

    private AtmosphereDataList   next = null;
    private boolean         disposed = false;

    static  AtmosphereDataList   dataList = null;

    private AtmosphereDataList()
    {
    }

    public static AtmosphereDataList getInstance()
    {
        AtmosphereDataList   l;

        if (dataList == null)
        {
            l = new AtmosphereDataList();
        }
        else
        {
            l = dataList;
            dataList = dataList.next;
        }

        l.disposed = false;
        l.data = null;
        l.tail = null;

        return l;
    }

    public void dispose()
    {
        if (this.disposed)
        {
            throw new IllegalStateException("attempt to free LightDataList already freed");
        }

        this.disposed = true;
        this.next = dataList;
        dataList = this;

        AtmosphereDataIterator it = this.iterator();

        while (it.hasNext())
        {
            it.next().dispose();
        }
    }

    public void add(
        AtmosphereData  newData)
    {
    	if (newData == null)
    	{
    		return;
    	}
    	
        if (tail == null)
        {
            data = tail = newData;
        }
        else
        {
            tail.next = newData;
            tail = newData;
        }
    }

    public AtmosphereDataIterator iterator()
    {
        return AtmosphereDataIterator.getInstance(data);
    }
}
