package org.autochthonous.graphics.rt;

public interface Illuminated
    extends Traceable
{
    public LightDataList visibleLights(Hit hit);

    /**
     * Return the atmospheres that affect the light coming back
     * from the hit.
     * 
     * @param hit the hit of interest.
     * 
     * @return a list of atmospheres that affect the light coming in.
     */
    public AtmosphereDataList affectingAtmospheres(Hit hit);
}
