package org.autochthonous.math.eqn;

public class Term
{
    private double  coef;               // constant coefficient
    private int     xPow, yPow, zPow;   // powers of x, y, and z

    public Term(
        double  v)
    {
        coef = v;
    }

    public Term(
        char    axis)
    {
        coef = 1;

        switch (axis)
        {
        case 'X':
        case 'x':
            xPow = 1;
            break;
        case 'Y':
        case 'y':
            yPow = 1;
            break;
        case 'Z':
        case 'z':
            zPow = 1;
            break;
        default:
            throw new IllegalArgumentException("unknown axis in term");
        }
    }

    public Term(
        double  coef,
        int     xPow,
        int     yPow,
        int     zPow)
    {
        this.coef = coef;
        this.xPow = xPow;
        this.yPow = yPow;
        this.zPow = zPow;
    }

    public int order()
    {
        int ord = xPow;

        if (yPow > ord)
        {
            ord = yPow;
        }

        if (zPow > ord)
        {
            ord = zPow;
        }

        return ord;
    }

    public double coefficient()
    {
        return coef;
    }

    public int xPow()
    {
        return xPow;
    }

    public int yPow()
    {
        return yPow;
    }

    public int zPow()
    {
        return zPow;
    }
}
